/**
 * @fileOverview jQuery.autosave
 *
 * @author Kyle Florence
 * @website https://github.com/kflorence/jquery-autosave
 * @version 1.2.1
 *
 * Inspired by the jQuery.autosave plugin written by Raymond Julin,
 * Mads Erik Forberg and Simen Graaten.
 *
 * Dual licensed under the MIT and BSD Licenses.
 */
(function(e,d,a,g){var f=(function(){var h=a.createElement("input");if("oninput" in h){return true}h.setAttribute("oninput","return;");return typeof h.oninput==="function"}());var b=function(k,i){var h={options:{}},j=typeof k;if(j==="function"){h.method=k}else{if(j==="string"&&i[k]){h.method=i[k].method}else{if(j==="object"){j=typeof k.method;if(j==="function"){h.method=k.method}else{if(j==="string"&&i[k.method]){h.method=i[k.method].method;h.options=e.extend(true,h.options,i[k.method].options,k.options)}}}}}return h};e.autosave={timer:0,$queues:e({}),states:{changed:"changed",modified:"modified"},options:{namespace:"autosave",callbacks:{trigger:"change",scope:null,data:"serialize",condition:null,save:"ajax"},events:{save:"save",saved:"saved",changed:"changed",modified:"modified"}},initialize:function(l,i){var h=this;this.$elements=l;this.options=e.extend(true,{},this.options,i);if(this.elements().length){var k,n=this.forms(),j=this.inputs();n.data(this.options.namespace,this);e.each(this.options.events,function(p,o){h.options.events[p]=[o,h.options.namespace].join(".")});e.each(this.options.callbacks,function(o,p){k=[];if(p){e.each(e.isArray(p)?p:[p],function(q,r){r=b(r,h.callbacks[o]);if(e.isFunction(r.method)){k.push(r)}})}h.options.callbacks[o]=k});n.bind([this.options.events.save,this.options.namespace].join("."),function(p,o){h.save(o,p.type)});j.bind(["change",this.options.namespace].join("."),function(o){e(this).data([h.options.namespace,h.states.changed].join("."),true);e(this.form).triggerHandler(h.options.events.changed,[this])});var m=f?"input":"keyup";j.bind([m,this.options.namespace].join("."),function(o){e(this).data([h.options.namespace,h.states.modified].join("."),true);e(this.form).triggerHandler(h.options.events.modified,[this])});e.each(this.options.callbacks.trigger,function(p,o){o.method.call(h,o.options)})}return l},elements:function(h){if(!h){h=this.$elements}return e(h).filter(function(){return(this.elements||this.form)})},forms:function(h){return e(e.unique(this.elements(h).map(function(){return this.elements?this:this.form}).get()))},inputs:function(h){return this.elements(h).map(function(){return this.elements?e.makeArray(e(this).find(":input")):this})},validInputs:function(h){return this.inputs(h)},changedInputs:function(h){var i=this;return this.inputs(h).filter(function(){return e(this).data([i.options.namespace,i.states.changed].join("."))})},modifiedInputs:function(h){var i=this;return this.inputs(h).filter(function(){return e(this).data([i.options.namespace,i.states.modified].join("."))})},startInterval:function(i){var h=this;i=i||this.interval;if(this.timer){this.stopInterval()}if(!isNaN(parseInt(i))){this.timer=setTimeout(function(){h.save(false,h.timer)},i)}},stopInterval:function(){clearTimeout(this.timer);this.timer=null},save:function(h,j){var i=this,m=false,k=this.validInputs(h);if(this.options.callbacks.save.length){e.each(this.options.callbacks.scope,function(o,p){k=p.method.call(i,p.options,k)});if(k.length){var n,l=true;e.each(this.options.callbacks.data,function(o,p){n=p.method.call(i,p.options,k,n)});e.each(this.options.callbacks.condition,function(o,p){return(l=p.method.call(i,p.options,k,n,j))!==false});if(l){e.each(this.options.callbacks.save,function(o,p){i.$queues.queue("save",function(){if(p.method.call(i,p.options,n)===false){i.resetFields()}else{i.next("save",true)}})});m=true}}}this.next("save",m)},next:function(j,i){var h=this.$queues.queue(j);if(h&&h.length){this.$queues.dequeue(j)}else{this.finished(h,j,i)}},resetFields:function(){this.inputs().data([this.options.namespace,this.states.changed].join("."),false);this.inputs().data([this.options.namespace,this.states.modified].join("."),false)},finished:function(h,j,i){if(j==="save"){if(h){this.forms().triggerHandler(this.options.events.saved)}if(i){this.resetFields()}if(this.timer){this.startInterval()}}}};var c=e.autosave.callbacks={};e.each(e.autosave.options.callbacks,function(h){c[h]={}});e.extend(c.trigger,{change:{method:function(){var h=this;this.forms().bind([this.options.events.changed,this.options.namespace].join("."),function(j,i){h.save(i,j.type)})}},modify:{method:function(){var h=this;this.forms().bind([this.options.events.modified,this.options.namespace].join("."),function(j,i){h.save(i,j.type)})}},interval:{method:function(h){if(!isNaN(parseInt(h.interval))){this.startInterval(this.interval=h.interval)}},options:{interval:30000}}});e.extend(c.scope,{all:{method:function(){return this.validInputs()}},changed:{method:function(){return this.changedInputs()}},modified:{method:function(){return this.modifiedInputs()}}});e.extend(c.data,{serialize:{method:function(h,i){return i.serialize()}},serializeArray:{method:function(h,i){return i.serializeArray()}},serializeObject:{method:function(h,i){var j={};e.each(i.serializeArray(),function(l,m){var p=m.name,k=m.value;j[p]=j[p]===g?k:e.isArray(j[p])?j[p].concat(k):[j[p],k]});return j}}});e.extend(c.condition,{interval:{method:function(i,j,k,h){return(!this.timer||this.timer===h)}},changed:{method:function(){return this.changedInputs().length>0}},modified:{method:function(){return this.modifiedInputs().length>0}}});e.extend(c.save,{ajax:{method:function(j,l){var i=this,m=e.extend({},j);m.complete=function(o,n){if(e.isFunction(j.complete)){j.complete.apply(i,arguments)}i.next("save")};if(e.isFunction(m.data)){m.data=m.data.call(i,l)}var k=e.type(l),h=e.type(m.data);if(h=="undefined"){m.data=l}else{if(k==h){switch(k){case"array":m.data=e.merge(l,m.data);break;case"object":m.data=e.extend(l,m.data);break;case"string":m.data=l+(l.length?"&":"")+m.data;break}}else{throw"Cannot merge form data with options data, must be of same type."}}e.ajax(m);return false},options:{url:d.location.href}}});e.fn.autosave=function(h){return e.extend({},e.autosave).initialize(this,h)}})(jQuery,window,document);
